unit jmena_f;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Spin;

const UM_START = WM_USER + 1;

type
  TForm1 = class(TForm)
    rb_m: TRadioButton;
    rb_z: TRadioButton;
    rb_v: TRadioButton;
    cbx_delka: TCheckBox;
    SpinEdit_delka: TSpinEdit;
    lbl_znaku: TLabel;
    ListBox1: TListBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure PostInit(var Message: TMessage); message UM_START;
    procedure FormDestroy(Sender: TObject);
    procedure cbx_delkaClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    ListM: TStringList; // Muzi
    ListZ: TStringList; // Zeny
    Maska: string;
    procedure ZmenaMasky(Sender: TObject);
    procedure ZmenaJmen(Sender: TObject);
    procedure OAplikaci();
  public
    procedure WMSysCommand (var Msg: TMessage); message wm_SysCommand;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{$R jmena_mz.res} // obsahuje standardni muzska a zenska jmena

const idSysOAplikaci = 100;

procedure TForm1.WMSysCommand (var Msg: TMessage);
begin
 if Msg.WParam = idSysOAplikaci then OAplikaci();
 inherited;
end;

procedure TForm1.OAplikaci();
begin
  Application.MessageBox(
   'Jmna 1.1' + #13 +
   'miniutilitka pro kovky' + #13#13 +
   'Petr Zednk' + #13 +
   'petr.zednik@volny.cz' + #13 +
   'www.volny.cz/petr.zednik/  ',
   'O aplikaci',MB_OK or MB_ICONINFORMATION);
end;

procedure TForm1.FormCreate(Sender: TObject);
var I: integer;
begin
  AppendMenu (GetSystemMenu (Handle, FALSE),
   MF_SEPARATOR, 0, '');
  AppendMenu (GetSystemMenu (Handle, FALSE),
   MF_STRING, idSysOAplikaci, 'O aplikaci');

  Application.Title := Form1.Caption;
  ListM := TStringList.Create;
  ListZ := TStringList.Create;
  SetLength(Maska, 16);
  FillChar(Maska[1],16,#0);

  for I := 1 to 16 do
    with TEdit(FindComponent('Edit' + IntToStr(i))) do
    begin
      Tag := I; {viz. ZmenaMasky}
      OnChange := ZmenaMasky;
    end;

  SpinEdit_delka.OnChange := ZmenaJmen;
  rb_m.OnClick := ZmenaJmen;
  rb_z.OnClick := ZmenaJmen;
  rb_v.OnClick := ZmenaJmen;

  PostMessage(Form1.handle,UM_START,0,0); // PostInit
end;

procedure TForm1.PostInit(var Message: TMessage);
var ResStream : TResourceStream;
    ListPom: TStringList;
    VstPar : string;
begin
  if ParamCount() > 0 then VstPar := UpperCase(ParamStr(1));

  // nacist standardni jmena z resource v EXE (ale ne pri tomto vst. parametru)
  if VstPar <> '/BEZSTD' then
  begin
    ResStream := TResourceStream.Create(HInstance,'JMENA_M',RT_RCDATA);
    ListM.LoadFromStream(ResStream);
    ResStream.Free;
    ResStream := TResourceStream.Create(HInstance,'JMENA_Z',RT_RCDATA);
    ListZ.LoadFromStream(ResStream);
    ResStream.Free;
  end;

  // pokud existuji i uzivatelska jmena, tak je pridat
  ListPom := TStringList.Create;
  try
    if FileExists('jmena_m.txt') then
    begin
      ListPom.LoadFromFile('jmena_m.txt');
      ListM.Sorted := true;
      ListM.Duplicates := dupIgnore;
      ListM.AddStrings(ListPom);
    end;

    if FileExists('jmena_z.txt') then
    begin
      ListPom.LoadFromFile('jmena_z.txt');
      ListZ.Sorted := true;
      ListZ.Duplicates := dupIgnore;
      ListZ.AddStrings(ListPom);
    end;
  except
    on Exception do
      Application.MessageBox(
       'Chyba pi natn soubor' + #13 +
       'jmena_m.txt a jmena_z.txt!',
       'Chyba',MB_OK or MB_ICONEXCLAMATION);
  end;
  ListPom.Free;

  ZmenaJmen(rb_v);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ListM.Free;
  ListZ.Free;
end;

procedure TForm1.cbx_delkaClick(Sender: TObject);
begin
  SpinEdit_delka.Enabled := cbx_delka.Checked;
  ZmenaJmen(Sender);
end;

procedure TForm1.ZmenaMasky(Sender: TObject);
begin
  with Sender as TEdit do
  begin
    // Edit1 az Edit16 ma v Tag cislo 1 az 16 (viz. FormCreate)
    if Text <> '' then
      Maska[Tag] := Text[1]
    else
      Maska[Tag] := #0;
  end;
  ZmenaJmen(Sender);
end;

procedure TForm1.ZmenaJmen(Sender: TObject);
var I, J, CelkPocet: integer;
    Jmeno : string;
    ListV: TStringList;
begin
  // znovunacteni a filtrace dat v listboxu
  // kvuli optimalizaci se to pripravi v seznamu ListV
  ListV := TStringList.Create;
  try
    if rb_m.Checked then
      ListV.Assign(ListM)
    else
    if rb_z.Checked then
      ListV.Assign(ListZ)
    else
    if rb_v.Checked then
    begin
      ListV.Assign(ListM);
      ListV.AddStrings(ListZ);
      ListV.Sorted := true;
    end;
    CelkPocet := ListV.Count;

    // filtrace (smazani tech, ktere neodpovidaji zadane masce)
    // pozn: musi se jit od konce kvuli pripadnemu mazani
    for I := CelkPocet - 1 downto 0 do
    begin
      Jmeno := ListV[I];

      if cbx_delka.Checked and
         (Length(Jmeno) <> SpinEdit_delka.Value) then
      begin
        ListV.Delete(I);
        Continue;
      end;

      for J := 1 to 16 do
        if (Maska[J] <> #0) and ((Length(Jmeno) < J) or (Maska[J] <> Jmeno[J])) then
        begin
          ListV.Delete(I);
          Break; // kdyz nesedi jeden znak nema smysl testovat dalsi znaky
        end;
    end;

    ListBox1.Items.Assign(ListV);
    StatusBar1.SimpleText :=
      'poet jmen = ' + IntToStr(ListV.Count) + '/' + IntToStr(CelkPocet);
  finally
    ListV.Free;
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_F1 then OAplikaci();
 if Key = VK_ESCAPE then Close;
end;

end.
